#include <dht.h>//biblioteca sensor dht11
#define sensorPir 4//declara sensor de presença pino 4

dht DHT; // Cria um objeto da classe dht

uint32_t timer = 0;//variavél tempo sensor dht11
unsigned long tempo;//variavél tempo para comparação acionamento
long tempoAcionamento = 3000; //variavél tempo de acionamento
String mensagem, cod = "001"; //variavél para comunicação com a dragonboard

void setup()
{
  pinMode(sensorPir, INPUT_PULLUP); //declara o sensor presença como sinal de entrada
  Serial.begin(9600);//inicializa a porta serial
}

void loop()
{
  if (millis() - timer >= 1000) // Executa 1 vez a cada 1 segundo
  {
    DHT.read11(A1); // chama método de leitura da classe dht, com o pino de transmissão de dados ligado no pino A1
    int aux = DHT.temperature;
    timer = millis(); // Atualiza a referência

    //condição para iniciar contagem de tempo
    if ((DHT.temperature <= 28) && (digitalRead(sensorPir) == HIGH))
    {
      tempo = millis();
    }

    //enquanto sensor estiver acionado conta tempo para enviar alarme pela serial
    while ((digitalRead(sensorPir) == HIGH) && (DHT.temperature <= 28))
     { 
      
      //condição para enviar alarme serial
      if (millis() > tempoAcionamento + tempo)
     {
        mensagem.concat('a');//concatena a na variavél menssagem
        mensagem.concat('+');//concatena sinal da tempera positivo ou negativo na variavél menssagem
        mensagem.concat(aux);//concatena temperatura na variavél menssagem
        mensagem.concat(cod);//concatena o codigo local na variavél menssagem
        Serial.println(mensagem);//envia alarme    
        mensagem = "";//limpa variavél 
        tempo = millis();//zera tempo de acionamento do alarme
      }
    }
  }
}
